VTK: vtkBSplineTransform Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkBSplineTransform Class Reference

a cubic b-spline deformation transformation More...

`#include <vtkBSplineTransform.h>`

Inheritance diagram for vtkBSplineTransform:
[legend]
Collaboration diagram for vtkBSplineTransform:
[legend]

## Public Types
typedef vtkWarpTransform | Superclass
Public Types inherited from vtkWarpTransform
typedef vtkAbstractTransform | Superclass
Public Types inherited from vtkAbstractTransform
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkBSplineTransform * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
vtkAbstractTransform * | MakeTransform () override
| Make another transform of the same type. More...
vtkMTimeType | GetMTime () override
| Get the MTime. More...
virtual void | SetCoefficientConnection (vtkAlgorithmOutput *)
| Set/Get the coefficient grid for the b-spline transform. More...
virtual void | SetCoefficientData (vtkImageData *)
| Set/Get the coefficient grid for the b-spline transform. More...
virtual vtkImageData * | GetCoefficientData ()
| Set/Get the coefficient grid for the b-spline transform. More...
virtual void | SetDisplacementScale (double)
| Set/Get a scale to apply to the transformation. More...
virtual double | GetDisplacementScale ()
| Set/Get a scale to apply to the transformation. More...
virtual void | SetBorderMode (int)
| Set/Get the border mode, to alter behavior at the edge of the grid. More...
void | SetBorderModeToEdge ()
| Set/Get the border mode, to alter behavior at the edge of the grid. More...
void | SetBorderModeToZero ()
| Set/Get the border mode, to alter behavior at the edge of the grid. More...
void | SetBorderModeToZeroAtBorder ()
| Set/Get the border mode, to alter behavior at the edge of the grid. More...
virtual int | GetBorderMode ()
| Set/Get the border mode, to alter behavior at the edge of the grid. More...
const char * | GetBorderModeAsString ()
| Set/Get the border mode, to alter behavior at the edge of the grid. More...
Public Member Functions inherited from vtkWarpTransform
vtkWarpTransform * | NewInstance () const
void | Inverse () override
| Invert the transformation. More...
virtual vtkTypeBool | GetInverseFlag ()
| Get the inverse flag of the transformation. More...
virtual void | SetInverseTolerance (double)
| Set the tolerance for inverse transformation. More...
virtual double | GetInverseTolerance ()
| Set the tolerance for inverse transformation. More...
virtual void | SetInverseIterations (int)
| Set the maximum number of iterations for the inverse transformation. More...
virtual int | GetInverseIterations ()
| Set the maximum number of iterations for the inverse transformation. More...
void | InternalTransformPoint (const float in[3], float out[3]) override
| This will calculate the transformation without calling Update. More...
void | InternalTransformPoint (const double in[3], double out[3]) override
| This will calculate the transformation without calling Update. More...
void | InternalTransformDerivative (const float in[3], float out[3], float derivative[3][3]) override
| This will calculate the transformation, as well as its derivative without calling Update. More...
void | InternalTransformDerivative (const double in[3], double out[3], double derivative[3][3]) override
| This will calculate the transformation, as well as its derivative without calling Update. More...
void | TemplateTransformPoint (const float in[3], float out[3])
| Do not use these methods. More...
void | TemplateTransformPoint (const double in[3], double out[3])
| Do not use these methods. More...
void | TemplateTransformPoint (const float in[3], float out[3], float derivative[3][3])
| Do not use these methods. More...
void | TemplateTransformPoint (const double in[3], double out[3], double derivative[3][3])
| Do not use these methods. More...
void | TemplateTransformInverse (const float in[3], float out[3])
| Do not use these methods. More...
void | TemplateTransformInverse (const double in[3], double out[3])
| Do not use these methods. More...
void | TemplateTransformInverse (const float in[3], float out[3], float derivative[3][3])
| Do not use these methods. More...
void | TemplateTransformInverse (const double in[3], double out[3], double derivative[3][3])
| Do not use these methods. More...
Public Member Functions inherited from vtkAbstractTransform
vtkAbstractTransform * | NewInstance () const
void | TransformPoint (const float in[3], float out[3])
| Apply the transformation to a coordinate. More...
void | TransformPoint (const double in[3], double out[3])
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (double x, double y, double z)
| Apply the transformation to a double-precision coordinate. More...
double * | TransformPoint (const double point[3])
double * | TransformNormalAtPoint (const double point[3], const double normal[3])
double * | TransformVectorAtPoint (const double point[3], const double vector[3])
virtual void | TransformPoints (vtkPoints *inPts, vtkPoints *outPts)
| Apply the transformation to a series of points, and append the results to outPts. More...
virtual void | TransformPointsNormalsVectors (vtkPoints *inPts, vtkPoints *outPts, vtkDataArray *inNms, vtkDataArray *outNms, vtkDataArray *inVrs, vtkDataArray *outVrs, int nOptionalVectors=0, vtkDataArray **inVrsArr=nullptr, vtkDataArray **outVrsArr=nullptr)
| Apply the transformation to a combination of points, normals and vectors. More...
vtkAbstractTransform * | GetInverse ()
| Get the inverse of this transform. More...
void | SetInverse (vtkAbstractTransform *transform)
| Set a transformation that this transform will be the inverse of. More...
void | DeepCopy (vtkAbstractTransform *)
| Copy this transform from another of the same type. More...
void | Update ()
| Update the transform to account for any changes which have been made. More...
virtual int | CircuitCheck (vtkAbstractTransform *transform)
| Check for self-reference. More...
void | UnRegister (vtkObjectBase *O) override
| Needs a special UnRegister() implementation to avoid circular references. More...
float * | TransformFloatPoint (float x, float y, float z)
| Apply the transformation to an (x,y,z) coordinate. More...
float * | TransformFloatPoint (const float point[3])
| Apply the transformation to an (x,y,z) coordinate. More...
double * | TransformDoublePoint (double x, double y, double z)
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
double * | TransformDoublePoint (const double point[3])
| Apply the transformation to a double-precision (x,y,z) coordinate. More...
void | TransformNormalAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a normal at the specified vertex. More...
void | TransformNormalAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a normal at the specified vertex. More...
double * | TransformDoubleNormalAtPoint (const double point[3], const double normal[3])
| Apply the transformation to a double-precision normal at the specified vertex. More...
float * | TransformFloatNormalAtPoint (const float point[3], const float normal[3])
| Apply the transformation to a single-precision normal at the specified vertex. More...
void | TransformVectorAtPoint (const float point[3], const float in[3], float out[3])
| Apply the transformation to a vector at the specified vertex. More...
void | TransformVectorAtPoint (const double point[3], const double in[3], double out[3])
| Apply the transformation to a vector at the specified vertex. More...
double * | TransformDoubleVectorAtPoint (const double point[3], const double vector[3])
| Apply the transformation to a double-precision vector at the specified vertex. More...
float * | TransformFloatVectorAtPoint (const float point[3], const float vector[3])
| Apply the transformation to a single-precision vector at the specified vertex. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkBSplineTransform * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkBSplineTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkWarpTransform
static vtkTypeBool | IsTypeOf (const char *type)
static vtkWarpTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAbstractTransform
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAbstractTransform * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkBSplineTransform ()
| ~vtkBSplineTransform () override
void | InternalUpdate () override
| Update the displacement grid. More...
void | InternalDeepCopy (vtkAbstractTransform *transform) override
| Copy this transform from another of the same type. More...
void | ForwardTransformDerivative (const float in[3], float out[3], float derivative[3][3]) override
| Calculate the forward transform as well as the derivative. More...
void | ForwardTransformDerivative (const double in[3], double out[3], double derivative[3][3]) override
| Calculate the forward transform as well as the derivative. More...
void | InverseTransformPoint (const float in[3], float out[3]) override
| If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint. More...
void | InverseTransformPoint (const double in[3], double out[3]) override
| If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint. More...
void | InverseTransformDerivative (const float in[3], float out[3], float derivative[3][3]) override
| Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform) More...
void | InverseTransformDerivative (const double in[3], double out[3], double derivative[3][3]) override
| Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform) More...
void | ForwardTransformPoint (const float in[3], float out[3]) override
| Internal functions for calculating the transformation. More...
void | ForwardTransformPoint (const double in[3], double out[3]) override
| Internal functions for calculating the transformation. More...
Protected Member Functions inherited from vtkWarpTransform
| vtkWarpTransform ()
| ~vtkWarpTransform () override
Protected Member Functions inherited from vtkAbstractTransform
| vtkAbstractTransform ()
| ~vtkAbstractTransform () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
void(* | CalculateSpline )(const double point[3], double displacement[3], double derivatives[3][3], void *gridPtr, int inExt[6], vtkIdType inInc[3], int borderMode)
double | DisplacementScale
int | BorderMode
void * | GridPointer
double | GridSpacing [3]
double | GridOrigin [3]
int | GridExtent [6]
vtkIdType | GridIncrements [3]
Protected Attributes inherited from vtkWarpTransform
vtkTypeBool | InverseFlag
int | InverseIterations
double | InverseTolerance
Protected Attributes inherited from vtkAbstractTransform
float | InternalFloatPoint [3]
double | InternalDoublePoint [3]
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

a cubic b-spline deformation transformation

vtkBSplineTransform computes a cubic b-spline transformation from a grid of b-spline coefficients.

Warning
  The inverse grid transform is calculated using an iterative method, and is several times more expensive than the forward transform.

See also
  vtkGeneralTransform vtkTransformToGrid vtkImageBSplineCoefficients

Thanks:
  This class was written by David Gobbi at the Seaman Family MR Research Centre, Foothills Medical Centre, Calgary, Alberta. DG Gobbi and YP Starreveld, "Uniform B-Splines for the VTK Imaging Pipeline," VTK Journal, 2011, http://hdl.handle.net/10380/3252

Tests:
  vtkBSplineTransform (Tests)

Definition at line 41 of file vtkBSplineTransform.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkWarpTransform vtkBSplineTransform::Superclass

Definition at line 45 of file vtkBSplineTransform.h.

## Constructor & Destructor Documentation

## ◆ vtkBSplineTransform()

vtkBSplineTransform::vtkBSplineTransform | ( |  | ) |
| protected

## ◆ ~vtkBSplineTransform()

vtkBSplineTransform::~vtkBSplineTransform | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkBSplineTransform* vtkBSplineTransform::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkBSplineTransform::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkBSplineTransform::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkWarpTransform.

## ◆ SafeDownCast()

static vtkBSplineTransform* vtkBSplineTransform::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkBSplineTransform::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkWarpTransform.

## ◆ NewInstance()

vtkBSplineTransform* vtkBSplineTransform::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkBSplineTransform::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkWarpTransform.

## ◆ SetCoefficientConnection()

virtual void vtkBSplineTransform::SetCoefficientConnection | ( | vtkAlgorithmOutput * |  | ) |
| virtual

Set/Get the coefficient grid for the b-spline transform.

The vtkBSplineTransform class will never modify the data. Note that SetCoefficientData() does not setup a pipeline connection whereas SetCoefficientConnection does.

## ◆ SetCoefficientData()

virtual void vtkBSplineTransform::SetCoefficientData | ( | vtkImageData * |  | ) |
| virtual

Set/Get the coefficient grid for the b-spline transform.

The vtkBSplineTransform class will never modify the data. Note that SetCoefficientData() does not setup a pipeline connection whereas SetCoefficientConnection does.

## ◆ GetCoefficientData()

virtual vtkImageData* vtkBSplineTransform::GetCoefficientData | ( |  | ) |
| virtual

Set/Get the coefficient grid for the b-spline transform.

The vtkBSplineTransform class will never modify the data. Note that SetCoefficientData() does not setup a pipeline connection whereas SetCoefficientConnection does.

## ◆ SetDisplacementScale()

virtual void vtkBSplineTransform::SetDisplacementScale | ( | double |  | ) |
| virtual

Set/Get a scale to apply to the transformation.

## ◆ GetDisplacementScale()

virtual double vtkBSplineTransform::GetDisplacementScale | ( |  | ) |
| virtual

Set/Get a scale to apply to the transformation.

## ◆ SetBorderMode()

virtual void vtkBSplineTransform::SetBorderMode | ( | int |  | ) |
| virtual

Set/Get the border mode, to alter behavior at the edge of the grid.

The Edge mode allows the displacement to converge to the edge coefficient past the boundary, which is similar to the behavior of the vtkGridTransform. The Zero mode allows the displacement to smoothly converge to zero two node-spacings past the boundary, which is useful when you want to create a localized transform. The ZeroAtBorder mode sacrifices smoothness to further localize the transform to just one node-spacing past the boundary.

## ◆ SetBorderModeToEdge()

void vtkBSplineTransform::SetBorderModeToEdge | ( |  | ) |
| inline

Set/Get the border mode, to alter behavior at the edge of the grid.

The Edge mode allows the displacement to converge to the edge coefficient past the boundary, which is similar to the behavior of the vtkGridTransform. The Zero mode allows the displacement to smoothly converge to zero two node-spacings past the boundary, which is useful when you want to create a localized transform. The ZeroAtBorder mode sacrifices smoothness to further localize the transform to just one node-spacing past the boundary.

Definition at line 80 of file vtkBSplineTransform.h.

## ◆ SetBorderModeToZero()

void vtkBSplineTransform::SetBorderModeToZero | ( |  | ) |
| inline

Set/Get the border mode, to alter behavior at the edge of the grid.

The Edge mode allows the displacement to converge to the edge coefficient past the boundary, which is similar to the behavior of the vtkGridTransform. The Zero mode allows the displacement to smoothly converge to zero two node-spacings past the boundary, which is useful when you want to create a localized transform. The ZeroAtBorder mode sacrifices smoothness to further localize the transform to just one node-spacing past the boundary.

Definition at line 81 of file vtkBSplineTransform.h.

## ◆ SetBorderModeToZeroAtBorder()

void vtkBSplineTransform::SetBorderModeToZeroAtBorder | ( |  | ) |
| inline

Set/Get the border mode, to alter behavior at the edge of the grid.

The Edge mode allows the displacement to converge to the edge coefficient past the boundary, which is similar to the behavior of the vtkGridTransform. The Zero mode allows the displacement to smoothly converge to zero two node-spacings past the boundary, which is useful when you want to create a localized transform. The ZeroAtBorder mode sacrifices smoothness to further localize the transform to just one node-spacing past the boundary.

Definition at line 82 of file vtkBSplineTransform.h.

## ◆ GetBorderMode()

virtual int vtkBSplineTransform::GetBorderMode | ( |  | ) |
| virtual

Set/Get the border mode, to alter behavior at the edge of the grid.

The Edge mode allows the displacement to converge to the edge coefficient past the boundary, which is similar to the behavior of the vtkGridTransform. The Zero mode allows the displacement to smoothly converge to zero two node-spacings past the boundary, which is useful when you want to create a localized transform. The ZeroAtBorder mode sacrifices smoothness to further localize the transform to just one node-spacing past the boundary.

## ◆ GetBorderModeAsString()

const char* vtkBSplineTransform::GetBorderModeAsString | ( |  | ) |

Set/Get the border mode, to alter behavior at the edge of the grid.

The Edge mode allows the displacement to converge to the edge coefficient past the boundary, which is similar to the behavior of the vtkGridTransform. The Zero mode allows the displacement to smoothly converge to zero two node-spacings past the boundary, which is useful when you want to create a localized transform. The ZeroAtBorder mode sacrifices smoothness to further localize the transform to just one node-spacing past the boundary.

## ◆ MakeTransform()

vtkAbstractTransform* vtkBSplineTransform::MakeTransform | ( |  | ) |
| overridevirtual

Make another transform of the same type.

Implements vtkAbstractTransform.

## ◆ GetMTime()

vtkMTimeType vtkBSplineTransform::GetMTime | ( |  | ) |
| overridevirtual

Get the MTime.

Reimplemented from vtkAbstractTransform.

## ◆ InternalUpdate()

void vtkBSplineTransform::InternalUpdate | ( |  | ) |
| overrideprotectedvirtual

Update the displacement grid.

Reimplemented from vtkAbstractTransform.

## ◆ InternalDeepCopy()

void vtkBSplineTransform::InternalDeepCopy | ( | vtkAbstractTransform * | transform | ) |
| overrideprotectedvirtual

Copy this transform from another of the same type.

Reimplemented from vtkAbstractTransform.

## ◆ ForwardTransformPoint() [1/2]

void vtkBSplineTransform::ForwardTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) |  |
| overrideprotectedvirtual

Internal functions for calculating the transformation.

Implements vtkWarpTransform.

## ◆ ForwardTransformPoint() [2/2]

void vtkBSplineTransform::ForwardTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) |  |
| overrideprotectedvirtual

Internal functions for calculating the transformation.

Implements vtkWarpTransform.

## ◆ ForwardTransformDerivative() [1/2]

void vtkBSplineTransform::ForwardTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the forward transform as well as the derivative.

Implements vtkWarpTransform.

## ◆ ForwardTransformDerivative() [2/2]

void vtkBSplineTransform::ForwardTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the forward transform as well as the derivative.

Implements vtkWarpTransform.

## ◆ InverseTransformPoint() [1/2]

void vtkBSplineTransform::InverseTransformPoint | ( | const float | in[3],
|  | float | out[3]
| ) |  |
| overrideprotectedvirtual

If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint.

The inverse transformation is calculated from using Newton's method.

Reimplemented from vtkWarpTransform.

## ◆ InverseTransformPoint() [2/2]

void vtkBSplineTransform::InverseTransformPoint | ( | const double | in[3],
|  | double | out[3]
| ) |  |
| overrideprotectedvirtual

If the InverseFlag is set to 1, then a call to InternalTransformPoint results in a call to InverseTransformPoint.

The inverse transformation is calculated from using Newton's method.

Reimplemented from vtkWarpTransform.

## ◆ InverseTransformDerivative() [1/2]

void vtkBSplineTransform::InverseTransformDerivative | ( | const float | in[3],
|  | float | out[3],
|  | float | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform)

Reimplemented from vtkWarpTransform.

## ◆ InverseTransformDerivative() [2/2]

void vtkBSplineTransform::InverseTransformDerivative | ( | const double | in[3],
|  | double | out[3],
|  | double | derivative[3][3]
| ) |  |
| overrideprotectedvirtual

Calculate the inverse transform as well as the derivative of the forward transform (that's correct: the derivative of the forward transform, not of the inverse transform)

Reimplemented from vtkWarpTransform.

## Member Data Documentation

## ◆ CalculateSpline

void(* vtkBSplineTransform::CalculateSpline) (const double point[3], double displacement[3], double derivatives[3][3], void *gridPtr, int inExt[6], vtkIdType inInc[3], int borderMode)
| protected

Definition at line 130 of file vtkBSplineTransform.h.

## ◆ DisplacementScale

double vtkBSplineTransform::DisplacementScale
| protected

Definition at line 133 of file vtkBSplineTransform.h.

## ◆ BorderMode

int vtkBSplineTransform::BorderMode
| protected

Definition at line 134 of file vtkBSplineTransform.h.

## ◆ GridPointer

void* vtkBSplineTransform::GridPointer
| protected

Definition at line 136 of file vtkBSplineTransform.h.

## ◆ GridSpacing

double vtkBSplineTransform::GridSpacing[3]
| protected

Definition at line 137 of file vtkBSplineTransform.h.

## ◆ GridOrigin

double vtkBSplineTransform::GridOrigin[3]
| protected

Definition at line 138 of file vtkBSplineTransform.h.

## ◆ GridExtent

int vtkBSplineTransform::GridExtent[6]
| protected

Definition at line 139 of file vtkBSplineTransform.h.

## ◆ GridIncrements

vtkIdType vtkBSplineTransform::GridIncrements[3]
| protected

Definition at line 140 of file vtkBSplineTransform.h.

The documentation for this class was generated from the following file:

- Filters/Hybrid/vtkBSplineTransform.h